/*	Copyright (c) 2004 Logic City, Inc. DBA My.TV
	All Rights Reserved
	Any works derived from this source code are property of Logic City, Inc.
	If you use this source code to write any other program or driver, the source
	for that derivative work must be sent to support@my.tv.  Logic City reserves the right
	to redistribute that work in source or executable form at no charge to Logic City.
*/
#include "stdafx.h"
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "MyBlasterUtil.h"

#define     kLineSize       255


int ReadCfg(char *tuner, char *comPort, int *ueitype, int *ueicode)
{
    FILE *fp;
    char cCurrentLine[kLineSize];
    char *ueitypeStr;
    char *tkn, *comStr, *rStr;
    int retval = FALSE;

    DbgMsg("ReadCfgFile:Start\n");
    DbgMsg("ReadCfgFile:Searching for tuner [%s]\n", tuner);
    if( (fp  = fopen( "c:\\capture\\tuner.txt", "r" )) == NULL )
    {
        DbgMsg( "ReadCfgFile:Err: CfgFile was not opened\n");
        goto end;
    }
    while ( !feof(fp) )
    {
        if (fgets( cCurrentLine, kLineSize, fp ) == NULL)
        {
            DbgMsg("ReadCfgFile:Empty fgets\n");
            continue;
        }
        tkn = strchr(cCurrentLine, '=');
        if (!tkn) {
            DbgMsg("ReadCfgFile: Missing '='\n");
            continue;
        }
        comStr = tkn+1;
        tkn[0] = 0;
        tkn = strchr(comStr, '&');
        ueitypeStr = tkn+1;
        tkn[0] = 0;
        tkn = strchr(ueitypeStr, ',');
        rStr = tkn+1;
        tkn[0] = 0;
        tkn = strchr(rStr, '.');
        tkn[0] = 0; 
        *ueitype = atoi(ueitypeStr);
        *ueicode = atoi(rStr);

        DbgMsg("Read [%s] port for tuner [%s]\n", comStr, cCurrentLine);
        if (strcmp(cCurrentLine, tuner) == 0) {
            DbgMsg("Tuner found  ueitype[%d] ueicode[%d]\n", *ueitype, *ueicode);
            strcpy(comPort, comStr);
            retval = TRUE;
            goto end;
        }
    }
end:
    fclose(fp);
    DbgMsg("ReadCfgFile:End [%d]\n", retval);
    return retval;
}
