/*	Copyright (c) 2004 Logic City, Inc. DBA My.TV
	All Rights Reserved
	Any works derived from this source code are property of Logic City, Inc.
	If you use this source code to write any other program or driver, the source
	for that derivative work must be sent to support@my.tv.  Logic City reserves the right
	to redistribute that work in source or executable form at no charge to Logic City.
*/
#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "MyBlasterUtil.h"

static void	getComPort(HANDLE* comport, char* comstr);
static int	MyBlasterVersion(HANDLE h);
static void _emit(HANDLE h, int key, int type, int code);

#define	DELAYBETWEEN	250

//	Tokenizes the output string, detects the COM port of the blaster then calls _emit
int Emit(HANDLE hndl, int data, int ueitype, int ueicode)	
{
    int     retval = TRUE;

    DbgMsg("Emit:Start\n");

    _emit(hndl,data,ueitype,ueicode);
    Sleep(DELAYBETWEEN);

	// _emit(h,17,ueitype,ueicode);  Add enter key
	//Sleep(DELAYBETWEEN);
end:
    DbgMsg("Emit:End [%d]\n", retval);
    return retval;
}

//	Cycle through all the COM ports looking for something that will respond to a Version command
//	NB: This is a Very slow routine.  You might want to use it once per reboot, then store the 
//	COM Port in a registry value or equivalent.
int detectComPortHandle(char *comStr, HANDLE *comPort)
{
	DCB	   dcb;
	COMMTIMEOUTS cto;
	LPCOMMCONFIG cc;
	DWORD cc_sz=sizeof(COMMCONFIG);
	BOOL   success = false;
	BOOL	found  = false;
	char	result[100];
	//char	tcomStr[10];
	char	DCBstr[20]="19200,n,8,1";
    int retval = FALSE;
	char moduleValue[10];
	DWORD size = 0;	

    DbgMsg("detectComPortHandle:Start\n");
	memset(result,0,100);

	getComPort(comPort, comStr);
	if (!*comPort) 	{
        DbgMsg("detectComPortHandle:Err:Invalid ComStr\n");
        retval = FALSE;
        goto end;
    }

    cc = new COMMCONFIG;
    cc->dwSize = sizeof(COMMCONFIG);

    success = GetDefaultCommConfig(comStr, cc, &cc_sz);
    success = SetCommConfig(*comPort, cc, cc_sz);

    delete cc;

    if (!GetCommState(*comPort, &dcb)) {
	    CloseHandle(*comPort);
        retval = FALSE;
        DbgMsg("detectComPortHandle:Err:Failed to get GetCommState\n");
        goto end;
    }

    FillMemory(&dcb, sizeof(dcb), 0);
    dcb.DCBlength = sizeof(dcb);
    if (!BuildCommDCB(DCBstr, &dcb))
	    exit(1);
    dcb.fDtrControl = DTR_CONTROL_DISABLE;
    dcb.fRtsControl = RTS_CONTROL_DISABLE;
    if (!SetCommState(*comPort, &dcb)) {
	    CloseHandle(*comPort);
        retval = FALSE;
        DbgMsg("detectComPortHandle:Err:Failed to get SetCommState\n");
        goto end;
    }
	
    // set all timeouts for 1 second
    cto.ReadIntervalTimeout = 5000;
    cto.ReadTotalTimeoutMultiplier = 5000;
    cto.ReadTotalTimeoutConstant = 5000;

    cto.WriteTotalTimeoutMultiplier = 500;
    cto.WriteTotalTimeoutConstant = 500;

    if (!SetCommTimeouts(*comPort, &cto)) {
	    CloseHandle(*comPort);
        retval = FALSE;
        DbgMsg("detectComPortHandle:Err:Failed to get SetCommTimeouts\n");
        goto end;
    }

	ReadFile(comPort, moduleValue, 10, &size, 0);

	cto.ReadIntervalTimeout = 500;
	cto.ReadTotalTimeoutMultiplier = 500;
	cto.ReadTotalTimeoutConstant = 500;

	cto.WriteTotalTimeoutMultiplier = 500;
	cto.WriteTotalTimeoutConstant = 500;

	if (!SetCommTimeouts(*comPort, &cto))
		CloseHandle(*comPort);

	success = MyBlasterVersion(*comPort);
    if (success == 1) {
		retval = 1;
        goto end;
    }

end:
    DbgMsg("detectComPortHandle:End [%d]\n", retval);
    return retval;
}


static void getComPort(HANDLE* comport, char* comstr)
{
    DbgMsg("getComPort:Start[%s]\n", comstr);
	*comport = CreateFile(
				comstr,
				GENERIC_READ | GENERIC_WRITE,
				0,
				NULL,
				OPEN_EXISTING,
				0,
				NULL);
    DbgMsg("getComPort:End\n");
}

static int MyBlasterVersion(HANDLE h)
{
	BYTE	data = 0;
	char	outbuf[1024];
	char	inbuf[1024];
	DWORD	size = 1;
    int retval = 0;

    DbgMsg("MyBlasterVersion:Start\n");
	memset(outbuf, 0, 1024);
	memset(inbuf, 0, 1024);

	// Wake up!
	outbuf[0] = 0;
	WriteFile(h, &outbuf, 1, &size, 0);
	Sleep(100);
	// Get Version Command Packet
	outbuf[0] = (char)0xbc;
	outbuf[1] = (char)0xac;
	outbuf[2] = (char)0x0d;
	outbuf[3] = (char)0x00;
	outbuf[4] = 1;			// record length
	outbuf[5] = 8;			// command = GetVersion
	WriteFile(h, &outbuf, 6, &size, 0);
	//DbgMsg("Past send key write: size %d command %d\n", size, data);
	Sleep(100);
	outbuf[0] = 0;
	WriteFile(h, &outbuf, 1, &size, 0);
	size = 0;
	ReadFile(h, &inbuf, 10, &size, 0);
	//DbgMsg("Past send key read: size %d\n", size);
	// Should have read back 10 bytes if there's a MyBlaster present

    DbgMsg("MyBlasterVersion:size[%d]\n", size);
    if (size == 10) {
        DbgMsg("Found blaster\n");
		retval = 1; 
        goto end;
    } else  {
        DbgMsg("No Blaster found\n");
		retval = 0;
        goto end;
    }
end:
    DbgMsg("MyBlasterVersion:End[%d]\n", retval);
    return retval;
}

//	NB: the MyBlaster protocol works in a timed fashion.  We really
//	recommend leaving the Sleep(msec) delays alone.  For example, when emitting
//	a key, if you don't sleep long enough before sending the termination packet, 
//	long codes (e.g. for Dish Satellite receivers) won't work.
static void _emit(HANDLE h, int key, int type, int code)
{
	int		flag;
	char	highbyte, lowbyte;
	char	outbuf[1024];
	char	inbuf[1024];
	DWORD	bufsize = 1;

	if (key == 0)			// delay key
	{
		Sleep(DELAYBETWEEN);
		Sleep(DELAYBETWEEN);
		return;
	}

	// Wake MyBlaster up!
	outbuf[0] = 0;
	flag = WriteFile(h, outbuf, 1, &bufsize, 0);
	Sleep(100);

	// Send the Emit packet
	outbuf[0] = (char)0xbc;
	outbuf[1] = (char)0xac;
	outbuf[2] = (char)0x0d;
	outbuf[3] = (char)0x00;
	outbuf[4] = 6;			// record length
	outbuf[5] = 1;			// command = sendKey
	highbyte = code / 256;
	lowbyte = code % 256;
	outbuf[6] = (type*16) | highbyte;		// device type = VCR
	outbuf[7] = lowbyte;	// VCR device code
	outbuf[8] = (BYTE)key;	// key code
	outbuf[9] = 0;			// key flag
	outbuf[10] = 0;
	flag = WriteFile(h, outbuf, 11, &bufsize, 0);
	Sleep(333);

	// Must terminate the emit after a certain point
	outbuf[0] = 0;
	flag = WriteFile(h, outbuf, 1, &bufsize, 0);

	// MyBlaster will return a 2-byte response which we ignore
	bufsize = 0;
	while (!bufsize) {
		flag = ReadFile(h, inbuf, 1, &bufsize, 0);
	}
	while (!bufsize) {
		flag = ReadFile(h, inbuf, 1, &bufsize, 0);
	}
}

void DbgMsg(char *szFormat, ...)
{
	char msg[255];
	va_list va;
    FILE *gLogfp;

	//format the string
    va_start(va,szFormat);
	vsprintf(msg,szFormat,va);
	va_end(va);

    // file must exisit for logging;
    if( (gLogfp  = fopen( "c:\\capture\\TunerDLL.log", "r" )) == NULL )
    {
        // no file  = no log
        goto end;
    }
    fclose(gLogfp);

    if( (gLogfp  = fopen( "c:\\capture\\TunerDLL.log", "a+" )) == NULL )
    {
        //DbgMsg( "ReadCfgFile:Err: File '%s' was not opened\n", fName );
        goto end;
    }

    fprintf( gLogfp, "%s", msg);
    fclose(gLogfp);
end:
    return;
}

